##############################################################################
#  
#  ZsapdbDA - a Database Adapter for Zope and sapdb
#  2001 by Ulrich Eck - net-labs Sytemhaus GmbH
#
##############################################################################
database_type='sapdb'
__doc__='''%s Database Connection

$Id: DA.py,v 1.2 2001/10/26 08:48:45 jack Exp $''' % database_type
__version__='$Revision: 1.2 $'[11:-2]

from db import DB
import Shared.DC.ZRDB.Connection, sys, DABase
from Globals import HTMLFile
from ImageFile import ImageFile
from ExtensionClass import Base

manage_addZsapdbConnectionForm=HTMLFile('connectionAdd',globals())

def manage_addZsapdbConnection(self, id, title,
                                connection_string,
                                check=None, REQUEST=None):
    """Add a DB connection to a folder"""
    self._setObject(id, Connection(
	id, title, connection_string, check))
    if REQUEST is not None: return self.manage_main(self,REQUEST)

class Connection(DABase.Connection):
    " "
    database_type=database_type
    id='%s_database_connection' % database_type
    meta_type=title='Z %s Database Connection' % database_type
    icon='misc_/Z%sDA/conn' % database_type

    def factory(self): return DB

    def table_info(self):
	return self._v_database_connection.table_info()

classes=('DA.Connection',)

meta_types=(
    {'name':'Z %s Database Connection' % database_type,
     'action':'manage_addZ%sConnectionForm' % database_type,
     },
    )

folder_methods={
    'manage_addZsapdbConnection':
    manage_addZsapdbConnection,
    'manage_addZsapdbConnectionForm':
    manage_addZsapdbConnectionForm,
    }

__ac_permissions__=(
    ('Add Z sapdb Database Connections',
     ('manage_addZsapdbConnectionForm',
      'manage_addZsapdbConnection')),
    )

misc_={
    'conn':   ImageFile('Shared/DC/ZRDB/www/DBAdapterFolder_icon.gif'),
    }

for icon in ('table', 'view', 'stable', 'what',
	     'field', 'text','bin','int','float',
	     'date','time','datetime'):
    misc_[icon]=ImageFile('icons/%s.gif' % icon, globals())
